public class SetWarshipsGeneric<T>{
    private T[] _places;

    public int getCount() {
        return _places != null ? _places.length : 0;
    }

    public SetWarshipsGeneric(int count)
    {
        _places = (T[]) new Object[count];
    }

    public int Insert(T warship)
    {
        return Insert(warship,0);
    }

    public int Insert(T warship, int position)
    {
        if (position < 0 || position >= getCount() || _places[position] == null)
            return -1;

        int empty = -1;
        for (int i = position + 1; i < getCount(); i++)
        {
            if (_places[i] == null)
                empty = i;
        }
        if (empty == -1)
            return 0;
        else
        {
            for (int i = empty; i > position; i--)
                _places[i] = _places[i - 1];
        }
        _places[position] = warship;
        return 1;
    }


    public T Remove(int position)
    {
        if (position >= getCount() || position < 0 || _places[position] == null)
            return null;

        T deleted =_places[position];
        _places[position] = null;
        return deleted;
    }

    public T Get(int position)
    {
        if (position >= getCount() || position < 0)
            return null;

        return _places[position];
    }
}
