import java.util.Random;

public class WarshipCreatorGeneric <T extends EntityWarship, U extends IDrawingObjectBlock>{
    T[] Warships;
    U[] Blocks;
    int WarshipsCount = 0;
    int BlocksCount = 0;
    public WarshipCreatorGeneric(int warshipsCount, int blocksCount){
        Warships = (T[])new Object[warshipsCount];
        Blocks = (U[]) new Object[blocksCount];
        WarshipsCount = warshipsCount;
        BlocksCount = blocksCount;
    }

    public int AddWarship(T warship){
        if(WarshipsCount<Warships.length){
            Warships[WarshipsCount]=warship;
            WarshipsCount++;
            return WarshipsCount-1;
        }
        return -1;
    }
    public int AddBlock(U block){
        if(BlocksCount<Blocks.length){
            Blocks[BlocksCount]=block;
            BlocksCount++;
            return BlocksCount-1;
        }
        return -1;
    }
    public DrawingWarship NewWarshipCreating()
    {
        Random rand=new Random();
        T warship = Warships[rand.nextInt(WarshipsCount)];
        U block = Blocks[rand.nextInt(BlocksCount)];
        if(warship instanceof EntityAircraftCarrier){
            return new DrawingAircraftCarrier(warship,block);
        }
        return new DrawingWarship(warship,block);
    }
}
